Index: /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/extrap.f90
===================================================================
--- /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/extrap.f90	(revision 5212)
+++ /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/extrap.f90	(revision 5213)
@@ -7,7 +7,86 @@
 ! DESCRIPTION:
 !> @brief 
-!> This module 
+!> This module manage extrapolation.
 !>
 !> @details
+!>    Extrapolation method to be used is specify inside variable 
+!>    strcuture, as array of string character.<br/> 
+!>    - td_var\%c_extrap(1) string character is the interpolation name choose between:
+!>       - 'dist_weight'
+!>       - 'min_error'
+!>
+!>    @note Extrapolation method could be specify for each variable in namelist _namvar_,
+!>    defining string character _cn\_varinfo_. By default _dist_weight_.<br/>
+!>    Example:
+!>       - cn_varinfo='varname1:dist_weight', 'varname2:min_error'
+!>
+!>    to detect point to be extrapolated:<br/>
+!> @code
+!>    il_detect(:,:,:)=extrap_detect(td_var, [td_level], [id_offset,] [id_rho,] [id_ext]) 
+!> @endcode
+!>       - il_detect(:,:,:) is 3D array of point to be extrapolated
+!>       - td_var  is coarse grid variable to be extrapolated
+!>       - td_level is fine grid array of level (see vgrid_get_level) [optional]
+!>       - id_offset is array of offset between fine and coarse grid [optional]
+!>       - id_rho    is array of refinment factor [optional]
+!>       - id_ext    is array of number of points to be extrapolated [optional]
+!>
+!>    to extrapolate variable:<br/>
+!> @code
+!>    CALL extrap_fill_value( td_var, [td_level], [id_offset], [id_rho], [id_iext], [id_jext], [id_kext], [id_radius], [id_maxiter])
+!> @endcode
+!>       - td_var  is coarse grid variable to be extrapolated
+!>       - td_level is fine grid array of level (see vgrid_get_level) [optional]
+!>       - id_offset is array of offset between fine and coarse grid [optional]
+!>       - id_rho    is array of refinment factor [optional]
+!>       - id_iext   is number of points to be extrapolated in i-direction [optional]
+!>       - id_jext   is number of points to be extrapolated in j-direction [optional]
+!>       - id_kext   is number of points to be extrapolated in k-direction [optional]
+!>       - id_radius is radius of the halo used to compute extrapolation [optional]
+!>       - id_maxiter is maximum number of iteration [optional]
+!>
+!>    to add extraband to the variable (to be extrapolated):<br/>
+!> @code
+!>    CALL extrap_add_extrabands(td_var, [id_isize,] [id_jsize] )
+!> @endcode
+!>       - td_var is variable structure
+!>       - id_isize : i-direction size of extra bands [optional]
+!>       - id_jsize : j-direction size of extra bands [optional]
+!>
+!>    to delete extraband of a variable:<br/>
+!> @code
+!>    CALL extrap_del_extrabands(td_var, [id_isize,] [id_jsize] )
+!> @endcode
+!>       - td_var is variable structure
+!>       - id_isize : i-direction size of extra bands [optional]
+!>       - id_jsize : j-direction size of extra bands [optional]
+!>
+!>    to compute first derivative of 1D array:<br/>
+!> @code
+!>    dl_value(:)=extrap_deriv_1D( dd_value(:), dd_fill, [ld_discont] )
+!> @endcode
+!>       - dd_value is 1D array of variable
+!>       - dd_fill is FillValue of variable
+!>       - ld_discont is logical to take into account longitudinal East-West discontinuity [optional]
+!>
+!>    to compute first derivative of 2D array:<br/>
+!> @code
+!>    dl_value(:,:)=extrap_deriv_2D( dd_value(:,:), dd_fill, cd_dim, [ld_discont] )
+!> @endcode
+!>       - dd_value is 2D array of variable
+!>       - dd_fill is FillValue of variable
+!>       - cd_dim is character to compute derivative on first (I) or second (J) dimension
+!>       - ld_discont is logical to take into account longitudinal East-West discontinuity [optional]
+!>
+!>    to compute first derivative of 3D array:<br/>
+!> @code
+!>    dl_value(:,:,:)=extrap_deriv_3D( dd_value(:,:,:), dd_fill, cd_dim, [ld_discont] )
+!> @endcode
+!>       - dd_value is 3D array of variable
+!>       - dd_fill is FillValue of variable
+!>       - cd_dim is character to compute derivative on first (I), second (J), or third (K) dimension
+!>       - ld_discont is logical to take into account longitudinal East-West discontinuity [optional]
+!>
+!> @warning _FillValue must not be zero (use var_chg_FillValue())
 !>
 !> @author
@@ -15,47 +94,50 @@
 ! REVISION HISTORY:
 !> @date Nov, 2013 - Initial Version
+!> @date September, 2014
+!> - add header
 !>
-!> @note WARNING: FillValue must not be zero (use var_chg_FillValue)
+!> @todo
+!> - create module for each extrapolation method
 !>
 !> @note Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
-!> @todo
-!> - something wrong when computing point to be extralopated
-!> - take care of ew value in variable structure
 !----------------------------------------------------------------------
 MODULE extrap
    USE netcdf                          ! nf90 library
-   USE kind
-   USE phycst
-   USE global
-   USE fct
-   USE logger
-   USE dim
-   USE att
-   USE var
+   USE kind                            ! F90 kind parameter
+   USE phycst                          ! physical constant
+   USE global                          ! global variable
+   USE fct                             ! basic useful function
+   USE date                            ! date manager
+   USE logger                          ! log file manager
+   USE att                             ! attribute manager
+   USE dim                             ! dimension manager
+   USE var                             ! variable manager
 
    IMPLICIT NONE
-   PRIVATE
    ! NOTE_avoid_public_variables_if_possible
 
    ! type and variable
+   PRIVATE :: im_maxiter   !< default maximum number of iteration 
+   PRIVATE :: im_minext    !< default minumum number of point to extrapolate
+   PRIVATE :: im_mincubic  !< default minumum number of point to extrapolate for cubic interpolation
 
    ! function and subroutine
    PUBLIC :: extrap_detect         !< detected point to be extrapolated
    PUBLIC :: extrap_fill_value     !< extrapolate value over detected point 
-   PUBLIC :: extrap_add_extrabands !< 
-   PUBLIC :: extrap_del_extrabands !< 
-   PUBLIC :: extrap_deriv_1D !< 
-   PUBLIC :: extrap_deriv_2D !< 
-
-   PRIVATE :: extrap__detect_wrapper !< detected point to be extrapolated
-   PRIVATE :: extrap__detect         !< detected point to be extrapolated
-   PRIVATE :: extrap__fill_value_wrapper     !< extrapolate value over detected point 
-   PRIVATE :: extrap__fill_value     !< extrapolate value over detected point 
-   PRIVATE :: extrap__3D
-   PRIVATE :: extrap_deriv_3D
-   PRIVATE :: extrap__3D_min_error_coef
-   PRIVATE :: extrap__3D_min_error_fill
-   PRIVATE :: extrap__3D_dist_weight_coef
-   PRIVATE :: extrap__3D_dist_weight_fill
+   PUBLIC :: extrap_add_extrabands !< add extraband to the variable (to be extrapolated) 
+   PUBLIC :: extrap_del_extrabands !< delete extraband of the variable 
+   PUBLIC :: extrap_deriv_1D       !< compute first derivative of 1D array 
+   PUBLIC :: extrap_deriv_2D       !< compute first derivative of 2D array 
+   PUBLIC :: extrap_deriv_3D       !< compute first derivative of 3D array
+
+   PRIVATE :: extrap__detect_wrapper      ! detected point to be extrapolated wrapper
+   PRIVATE :: extrap__detect              ! detected point to be extrapolated
+   PRIVATE :: extrap__fill_value_wrapper  ! extrapolate value over detected point wrapper 
+   PRIVATE :: extrap__fill_value          ! extrapolate value over detected point 
+   PRIVATE :: extrap__3D                  !
+   PRIVATE :: extrap__3D_min_error_coef   !
+   PRIVATE :: extrap__3D_min_error_fill   !
+   PRIVATE :: extrap__3D_dist_weight_coef !
+   PRIVATE :: extrap__3D_dist_weight_fill ! 
 
    INTEGER(i4), PARAMETER :: im_maxiter = 10 !< default maximum number of iteration
@@ -64,5 +146,5 @@
 
    INTERFACE extrap_detect
-      MODULE PROCEDURE extrap__detect_wrapper !< detected point to be extrapolated
+      MODULE PROCEDURE extrap__detect_wrapper     !< detected point to be extrapolated
    END INTERFACE extrap_detect
 
@@ -74,23 +156,33 @@
    !-------------------------------------------------------------------
    !> @brief
-   !> This function detected point to be extrapolated.
+   !> This function detected point to be extrapolated, given variable structure.
    !> 
    !> @details 
+   !> optionaly, you could sepcify fine grid level, refinment factor (default 1), 
+   !> offset between fine and coarse grid (default compute from refinment factor
+   !> as offset=(rho-1)/2), number of point to be extrapolated in each direction
+   !> (default im_minext).<br/>
    !>
+   !> First coarsening fine grid level, if need be, then select point near 
+   !> grid point already inform.
+   !>
+   !> @note point to be extrapolated are selected using FillValue, 
+   !> so to avoid mistake FillValue should not be zero (use var_chg_FillValue)
+   !> 
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
+   !> - November, 2013- Initial Version
    !
-   !> @param[in] td_var : variable to extrapolate
-   !> @param[in] id_iext : number of points to be extrapolated in i-direction
-   !> @param[in] id_jext : number of points to be extrapolated in j-direction
-   !> @param[in] id_kext : number of points to be extrapolated in k-direction
-   !> @return
-   !-------------------------------------------------------------------
-   !> @code
+   !> @param[in] td_var0   coarse grid variable to extrapolate
+   !> @param[in] td_level1 fine grid array of level
+   !> @param[in] id_offset array of offset between fine and coarse grid 
+   !> @param[in] id_rho    array of refinment factor 
+   !> @param[in] id_ext    array of number of points to be extrapolated
+   !> @return array of point to be extrapolated
+   !-------------------------------------------------------------------
    FUNCTION extrap__detect( td_var0, td_level1, &
    &                        id_offset, id_rho, id_ext )
       IMPLICIT NONE
       ! Argument
-      TYPE(TVAR) ,                 INTENT(INOUT) :: td_var0
+      TYPE(TVAR) ,                 INTENT(IN   ) :: td_var0
       TYPE(TVAR) , DIMENSION(:)  , INTENT(IN   ), OPTIONAL :: td_level1
       INTEGER(i4), DIMENSION(:,:), INTENT(IN   ), OPTIONAL :: id_offset
@@ -106,6 +198,7 @@
       CHARACTER(LEN=lc)                                :: cl_level
 
-      INTEGER(i4)                                      :: il_varid
+      INTEGER(i4)                                      :: il_ind
       INTEGER(i4)      , DIMENSION(:,:,:), ALLOCATABLE :: il_detect
+      INTEGER(i4)      , DIMENSION(:,:,:), ALLOCATABLE :: il_tmp
       INTEGER(i4)      , DIMENSION(:,:)  , ALLOCATABLE :: il_offset
       INTEGER(i4)      , DIMENSION(:,:)  , ALLOCATABLE :: il_level1
@@ -143,9 +236,10 @@
       ALLOCATE( il_offset(ip_maxdim,2) )
       il_offset(:,:)=0
-      il_offset(jp_I,:)=FLOOR(REAL(il_rho(jp_I)-1,dp)*0.5)
-      il_offset(jp_J,:)=FLOOR(REAL(il_rho(jp_J)-1,dp)*0.5)
       IF( PRESENT(id_offset) )THEN
          il_offset(1:SIZE(id_offset(:,:),DIM=1),&
          &         1:SIZE(id_offset(:,:),DIM=2) )= id_offset(:,:)
+      ELSE
+         il_offset(jp_I,:)=FLOOR(REAL(il_rho(jp_I)-1,dp)*0.5)
+         il_offset(jp_J,:)=FLOOR(REAL(il_rho(jp_J)-1,dp)*0.5)
       ENDIF
 
@@ -160,19 +254,26 @@
 
       ! select point already inform
-      WHERE( td_var0%d_value(:,:,:,1) /= td_var0%d_fill ) il_detect(:,:,:)=1
+      DO jk0=1,td_var0%t_dim(3)%i_len
+         DO jj0=1,td_var0%t_dim(2)%i_len
+            DO ji0=1,td_var0%t_dim(1)%i_len
+               IF( td_var0%d_value(ji0,jj0,jk0,1) /= td_var0%d_fill ) il_detect(ji0,jj0,jk0)=1
+            ENDDO
+         ENDDO
+      ENDDO
  
       IF( PRESENT(td_level1) )THEN
          SELECT CASE(TRIM(td_var0%c_point))
-         CASE DEFAULT !'T'
-            cl_level='tlevel'
-         CASE('U')
-            cl_level='ulevel'
-         CASE('V')
-            cl_level='vlevel'
-         CASE('F')
-            cl_level='flevel'
+            CASE DEFAULT !'T'
+               cl_level='tlevel'
+            CASE('U')
+               cl_level='ulevel'
+            CASE('V')
+               cl_level='vlevel'
+            CASE('F')
+               cl_level='flevel'
          END SELECT
-         il_varid=var_get_id(td_level1(:),TRIM(cl_level))
-         IF( il_varid == 0 )THEN
+
+         il_ind=var_get_index(td_level1(:),TRIM(cl_level))
+         IF( il_ind == 0 )THEN
             CALL logger_error("EXTRAP DETECT: can not compute point to be "//&
             &     "extrapolated for variable "//TRIM(td_var0%c_name)//&
@@ -180,84 +281,66 @@
             &     "level for variable point "//TRIM(TRIM(td_var0%c_point)))
          ELSE
-            print *,'read ',trim(cl_level)
-            tl_var1=td_level1(il_varid)
+            tl_var1=var_copy(td_level1(il_ind))
+
+            ALLOCATE( il_level1_G0( il_dim0(1), il_dim0(2)) )
+            IF( ALL(tl_var1%t_dim(1:2)%i_len == il_dim0(1:2)) )THEN
+
+               ! variable to be extrapolated use same resolution than level
+               il_level1_G0(:,:)=INT(tl_var1%d_value(:,:,1,1),i4)
+               
+            ELSE
+               ! variable to be extrapolated do not use same resolution than level
+               ALLOCATE( il_level1(tl_var1%t_dim(1)%i_len, &
+               &                   tl_var1%t_dim(2)%i_len) )
+               ! match fine grid vertical level with coarse grid
+               il_level1(:,:)=INT(tl_var1%d_value(:,:,1,1),i4)/il_rho(jp_K)
+
+               ALLOCATE( il_extra(ip_maxdim,2) )
+               ! coarsening fine grid level
+               il_extra(jp_I,1)=CEILING(REAL(il_rho(jp_I)-1,dp)*0.5_dp)
+               il_extra(jp_I,2)=FLOOR(REAL(il_rho(jp_I)-1,dp)*0.5_dp)
+
+               il_extra(jp_J,1)=CEILING(REAL(il_rho(jp_J)-1,dp)*0.5_dp)
+               il_extra(jp_J,2)=FLOOR(REAL(il_rho(jp_J)-1,dp)*0.5_dp)
+
+               DO jj0=1,td_var0%t_dim(2)%i_len
+                  
+                  jj1=(jj0-1)*il_rho(jp_J)+1-il_offset(jp_J,1)
+
+                  jj1m=MAX( jj1-il_extra(jp_J,1), 1 )
+                  jj1p=MIN( jj1+il_extra(jp_J,2), &
+                  &         tl_var1%t_dim(2)%i_len-il_offset(jp_J,2) )
+                  
+                  DO ji0=1,td_var0%t_dim(1)%i_len
+
+                     ji1=(ji0-1)*il_rho(jp_I)+1-id_offset(jp_I,1)
+
+                     ji1m=MAX( ji1-il_extra(jp_I,1), 1 )
+                     ji1p=MIN( ji1+il_extra(jp_I,2), &
+                     &         tl_var1%t_dim(1)%i_len-id_offset(jp_I,2) )
+               
+                     il_level1_G0(ji0,jj0)=MAXVAL(il_level1(ji1m:ji1p,jj1m:jj1p))
+
+                  ENDDO
+               ENDDO
+
+               ! clean
+               DEALLOCATE( il_extra )
+               DEALLOCATE( il_level1 )
+
+            ENDIF
+
+            ! look for sea point
+            DO jk0=1,td_var0%t_dim(3)%i_len
+               WHERE( il_level1_G0(:,:) >= jk0)
+                  il_detect(:,:,jk0)=1
+               END WHERE
+            ENDDO
+
+            ! clean
+            DEALLOCATE( il_level1_G0 )
+            CALL var_clean(tl_var1)
+
          ENDIF
-
-         ALLOCATE( il_level1_G0( il_dim0(1), il_dim0(2)) )
-         IF( ALL(tl_var1%t_dim(1:2)%i_len == il_dim0(1:2)) )THEN
-
-            ! variable to be extrapolated use same resolution than level
-            il_level1_G0(:,:)=INT(tl_var1%d_value(:,:,1,1),i4)
-            
-         ELSE
-            ! variable to be extrapolated do not use same resolution than level
-            ALLOCATE( il_level1(tl_var1%t_dim(1)%i_len, &
-            &                   tl_var1%t_dim(2)%i_len) )
-            ! match fine grid vertical level with coarse grid
-            il_level1(:,:)=INT(tl_var1%d_value(:,:,1,1),i4)/il_rho(jp_K)
-
-            ALLOCATE( il_extra(ig_ndim,2) )
-            ! coarsening fine grid level
-            il_extra(jp_I,1)=CEILING(REAL(il_rho(jp_I)-1,dp)/2._dp)
-            il_extra(jp_I,2)=FLOOR(REAL(il_rho(jp_I)-1,dp)/2._dp)
-
-            il_extra(jp_J,1)=CEILING(REAL(il_rho(jp_J)-1,dp)/2._dp)
-            il_extra(jp_J,2)=FLOOR(REAL(il_rho(jp_J)-1,dp)/2._dp)
-
-            DO jj0=1,td_var0%t_dim(2)%i_len
-               
-               jj1=(jj0-1)*il_rho(jp_J)+1-il_offset(jp_J,1)
-
-               jj1m=MAX( jj1-il_extra(jp_J,1), 1 )
-               jj1p=MIN( jj1+il_extra(jp_J,2), &
-               &         tl_var1%t_dim(2)%i_len-il_offset(jp_J,2) )
-               
-               DO ji0=1,td_var0%t_dim(1)%i_len
-
-                  ji1=(ji0-1)*il_rho(jp_I)+1-id_offset(jp_I,1)
-
-                  ji1m=MAX( ji1-il_extra(jp_I,1), 1 )
-                  ji1p=MIN( ji1+il_extra(jp_I,2), &
-                  &         tl_var1%t_dim(1)%i_len-id_offset(jp_I,2) )
-            
-                  il_level1_G0(ji0,jj0)=MAXVAL(il_level1(ji1m:ji1p,jj1m:jj1p))
-               ENDDO
-            ENDDO
-
-            !il_level1_G0(:,:)=0
-            !DO jj1=1,tl_var1%t_dim(2)%i_len
-      
-            !   jj0=INT(REAL((jj1+il_offset(jp_J,1)-1)-1,dp)/REAL(il_rho(jp_J),dp)) +1
-
-            !   DO ji1=1,tl_var1%t_dim(1)%i_len
-
-            !      ji0=INT(REAL((ji1+il_offset(jp_I,1)-1)-1,dp)/REAL(il_rho(jp_I),dp)) +1
-
-            !      il_level1_G0(ji0,jj0)=MAX(il_level1_G0(ji0,jj0),il_level1(ji1,jj1))
-            !      
-            !   ENDDO
-            !ENDDO
-
-            ! clean
-            DEALLOCATE( il_extra )
-            DEALLOCATE( il_level1 )
-
-         ENDIF
-
-         ! look for sea point
-         !il_detect(:,:,1)=0
-         DO jk0=1,td_var0%t_dim(3)%i_len
-            WHERE( il_level1_G0(:,:) >= jk0)
-               il_detect(:,:,jk0)=1
-            END WHERE
-            !il_detect(:,:,jk0)=il_level1_G0(:,:)
-            !WHERE( td_var0%d_value(:,:,jk0,1) /= td_var0%d_fill )
-            !   il_detect(:,:,1)=jk0-1
-            !END WHERE
-         ENDDO
-
-         ! clean
-         DEALLOCATE( il_level1_G0 )
-
       ENDIF
 
@@ -265,19 +348,37 @@
       DEALLOCATE( il_offset )
  
-      !! select extra point depending on interpolation method
-      !! compute point near grid point already inform
-      !FORALL( ji0=1:il_dim0(1), &
-      !&       jj0=1:il_dim0(2), &
-      !&       jk0=1:il_dim0(3), &
-      !&       il_detect(ji0,jj0,jk0) == 1 )
-
-      !   il_detect(MAX(1,ji0-il_ext(jp_I)):MIN(ji0+il_ext(jp_I),il_dim0(1)),&
-      !   &         MAX(1,jj0-il_ext(jp_J)):MIN(jj0+il_ext(jp_J),il_dim0(2)),&
-      !   &         MAX(1,jk0-il_ext(jp_K)):MIN(jk0+il_ext(jp_K),il_dim0(3)) )=1 
-
-      !END FORALL
+      ALLOCATE( il_tmp(il_dim0(1),&
+      &                il_dim0(2),&
+      &                il_dim0(3)) )
+      il_tmp(:,:,:)=il_detect(:,:,:)
+      ! select extra point depending on interpolation method
+      ! compute point near grid point already inform
+      DO jk0=1,il_dim0(3)
+         DO jj0=1,il_dim0(2)
+            DO ji0=1,il_dim0(1)
+
+               IF( il_tmp(ji0,jj0,jk0) == 1 )THEN
+                  il_detect( &
+                  &  MAX(1,ji0-il_ext(jp_I)):MIN(ji0+il_ext(jp_I),il_dim0(1)),&
+                  &  MAX(1,jj0-il_ext(jp_J)):MIN(jj0+il_ext(jp_J),il_dim0(2)),&
+                  &  MAX(1,jk0-il_ext(jp_K)):MIN(jk0+il_ext(jp_K),il_dim0(3)) &
+                  &  ) = 1 
+               ENDIF
+
+            ENDDO
+         ENDDO
+      ENDDO
       
+      ! clean
+      DEALLOCATE( il_tmp )
+
       ! do not compute grid point already inform
-      WHERE( td_var0%d_value(:,:,:,1) /= td_var0%d_fill ) il_detect(:,:,:)=0
+      DO jk0=1,td_var0%t_dim(3)%i_len
+         DO jj0=1,td_var0%t_dim(2)%i_len
+            DO ji0=1,td_var0%t_dim(1)%i_len
+               IF( td_var0%d_value(ji0,jj0,jk0,1) /= td_var0%d_fill ) il_detect(ji0,jj0,jk0)=0
+            ENDDO
+         ENDDO
+      ENDDO
 
       ! save result
@@ -288,23 +389,22 @@
       DEALLOCATE( il_ext )
       DEALLOCATE( il_detect )
+      DEALLOCATE( il_rho )
 
    END FUNCTION extrap__detect
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This function detected point to be extrapolated.
+   !> This function sort variable to be extrapolated, depending on number of
+   !> dimentsion, then detected point to be extrapolated.
    !> 
-   !> @details 
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
    !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_var : variable to extrapolate
-   !> @param[in] id_iext : number of points to be extrapolated in i-direction
-   !> @param[in] id_jext : number of points to be extrapolated in j-direction
-   !> @param[in] id_kext : number of points to be extrapolated in k-direction
-   !> @return
-   !-------------------------------------------------------------------
-   !> @code
+   !> @param[in] td_var    coarse grid variable to extrapolate
+   !> @param[in] td_level  fine grid array of level
+   !> @param[in] id_offset array of offset between fine and coarse grid 
+   !> @param[in] id_rho    array of refinment factor 
+   !> @param[in] id_ext    array of number of points to be extrapolated
+   !> @return 3D array of point to be extrapolated
+   !-------------------------------------------------------------------
    FUNCTION extrap__detect_wrapper( td_var, td_level, &
    &                                id_offset, id_rho, id_ext )
@@ -312,6 +412,6 @@
       IMPLICIT NONE
       ! Argument
-      TYPE(TVAR) ,                         INTENT(INOUT) :: td_var
-      TYPE(TVAR) , DIMENSION(:)          , INTENT(IN   ), OPTIONAL :: td_level
+      TYPE(TVAR) ,                 INTENT(IN   ) :: td_var
+      TYPE(TVAR) , DIMENSION(:)  , INTENT(IN   ), OPTIONAL :: td_level
       INTEGER(i4), DIMENSION(:,:), INTENT(IN   ), OPTIONAL :: id_offset
       INTEGER(i4), DIMENSION(:)  , INTENT(IN   ), OPTIONAL :: id_rho
@@ -335,5 +435,5 @@
       ELSE IF( ALL(td_var%t_dim(1:3)%l_use) )THEN
          
-         ! detect point to be interpolated on I-J-K
+         ! detect point to be extrapolated on I-J-K
          CALL logger_debug(" EXTRAP DETECT: detect point "//&
          &              " for variable "//TRIM(td_var%c_name) )
@@ -346,5 +446,5 @@
       ELSE IF( ALL(td_var%t_dim(1:2)%l_use) )THEN
 
-         ! detect point to be interpolated on I-J
+         ! detect point to be extrapolated on I-J
          CALL logger_debug(" EXTRAP DETECT: detect horizontal point "//&
          &              " for variable "//TRIM(td_var%c_name) )
@@ -357,5 +457,5 @@
       ELSE IF( td_var%t_dim(3)%l_use )THEN
          
-         ! detect point to be interpolated on K
+         ! detect point to be extrapolated on K
          CALL logger_debug(" EXTRAP DETECT: detect vertical point "//&
          &              " for variable "//TRIM(td_var%c_name) )
@@ -373,98 +473,32 @@
       
    END FUNCTION extrap__detect_wrapper
-   !> @endcode
-!   !-------------------------------------------------------------------
-!   !> @brief
-!   !> This function detected point to be extrapolated.
-!   !> 
-!   !> @details 
-!   !>
-!   !> @author J.Paul
-!   !> - Nov, 2013- Initial Version
-!   !
-!   !> @param[in] td_var : variable to extrapolate
-!   !> @param[in] id_iext : number of points to be extrapolated in i-direction
-!   !> @param[in] id_jext : number of points to be extrapolated in j-direction
-!   !> @param[in] id_kext : number of points to be extrapolated in k-direction
-!   !> @return 
-!   !
-!   !> @todo
-!   !-------------------------------------------------------------------
-!   !> @code
-!   FUNCTION extrap__detect(td_var, id_iext, id_jext, id_kext)
-!      IMPLICIT NONE
-!      ! Argument
-!      TYPE(TVAR) ,                   INTENT(INOUT) :: td_var
-!      !INTEGER(i4), DIMENSION(:,:,:), INTENT(OUT  ) :: id_detect
-!      INTEGER(i4),                   INTENT(IN   ), OPTIONAL :: id_iext
-!      INTEGER(i4),                   INTENT(IN   ), OPTIONAL :: id_jext
-!      INTEGER(i4),                   INTENT(IN   ), OPTIONAL :: id_kext
-!
-!      ! function
-!      INTEGER(i4), DIMENSION(td_var%t_dim(1)%i_len, &
-!      &                      td_var%t_dim(2)%i_len, &
-!      &                      td_var%t_dim(3)%i_len) :: extrap__detect
-!
-!      ! local variable
-!      INTEGER(i4) :: il_iext
-!      INTEGER(i4) :: il_jext
-!      INTEGER(i4) :: il_kext
-!
-!      INTEGER(i4), DIMENSION(3) :: il_dim
-!
-!      ! loop indices
-!      INTEGER(i4) :: ji
-!      INTEGER(i4) :: jj
-!      INTEGER(i4) :: jk
-!      !----------------------------------------------------------------
-!
-!      ! optional argument
-!      il_iext=im_minext
-!      IF( PRESENT(id_iext) ) il_iext=id_iext
-!      il_jext=im_minext
-!      IF( PRESENT(id_jext) ) il_jext=id_jext
-!      il_kext=im_minext
-!      IF( PRESENT(id_kext) ) il_kext=id_kext
-!
-!      ! init
-!      extrap__detect(:,:,:)=0
-!
-!      il_dim(:)=td_var%t_dim(1:3)%i_len
-!
-!      ! compute point near grid point already inform
-!      FORALL( ji=1:il_dim(1), &
-!      &       jj=1:il_dim(2), &
-!      &       jk=1:il_dim(3), &
-!      &       td_var%d_value(ji,jj,jk,1) /= td_var%d_fill )
-!
-!         extrap__detect(MAX(1,ji-il_iext):MIN(ji+il_iext,il_dim(1)),&
-!         &              MAX(1,jj-il_jext):MIN(jj+il_jext,il_dim(2)),&
-!         &              MAX(1,jk-il_kext):MIN(jk+il_kext,il_dim(3)) )=1 
-!
-!
-!      END FORALL
-!      
-!      ! do not compute grid point already inform
-!      WHERE( td_var%d_value(:,:,:,1) /= td_var%d_fill ) extrap__detect(:,:,:)=0
-!
-!   END FUNCTION extrap__detect
-!   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This subroutine
+   !> This subroutine select method to be used for extrapolation.
+   !> If need be, increase number of points to be extrapolated.
+   !> Finally launch extrap__fill_value.
    !> 
-   !> @details 
+   !> @details
+   !> optionaly, you could specify :<br/>
+   !>  - refinment factor (default 1)
+   !>  - offset between fine and coarse grid (default compute from refinment factor
+   !> as offset=(rho-1)/2) 
+   !>  - number of point to be extrapolated in each direction (default im_minext)
+   !>  - radius of the halo used to compute extrapolation
+   !>  - maximum number of iteration
    !>
    !> @author J.Paul
    !> - Nov, 2013- Initial Version
    !
-   !> @param[inout] td_var : variable structure
-   !> @param[in] id_iext : number of points to be extrapolated in i-direction
-   !> @param[in] id_jext : number of points to be extrapolated in j-direction
-   !> @param[in] id_kext : number of points to be extrapolated in k-direction
-   !> @param[in] id_extend :  radius of the box used to compute extrapolation 
-   !> @param[in] id_maxiter : maximum nuber of iteration
-   !-------------------------------------------------------------------
-   !> @code
+   !> @param[inout] td_var    variable structure
+   !> @param[in] td_level     fine grid array of level
+   !> @param[in] id_offset    array of offset between fine and coarse grid 
+   !> @param[in] id_rho       array of refinment factor 
+   !> @param[in] id_iext      number of points to be extrapolated in i-direction
+   !> @param[in] id_jext      number of points to be extrapolated in j-direction
+   !> @param[in] id_kext      number of points to be extrapolated in k-direction
+   !> @param[in] id_radius    radius of the halo used to compute extrapolation 
+   !> @param[in] id_maxiter   maximum number of iteration
+   !-------------------------------------------------------------------
    SUBROUTINE extrap__fill_value_wrapper( td_var, td_level, &
    &                                      id_offset,        &
@@ -496,5 +530,5 @@
       !----------------------------------------------------------------
       IF( .NOT. ASSOCIATED(td_var%d_value) )THEN
-         CALL logger_error("EXTRAP FILL VALUE: no table of value "//&
+         CALL logger_error("EXTRAP FILL VALUE: no value "//&
          &  "associted to variable "//TRIM(td_var%c_name) )
       ELSE
@@ -542,6 +576,5 @@
          IF( (il_iext /= 0 .AND. td_var%t_dim(1)%l_use) .OR. &
          &   (il_jext /= 0 .AND. td_var%t_dim(2)%l_use) .OR. &
-         &   (il_kext /= 0 .AND. td_var%t_dim(3)%l_use) .OR. &
-         &   PRESENT(td_level) )THEN
+         &   (il_kext /= 0 .AND. td_var%t_dim(3)%l_use) )THEN
 
             ! number of point use to compute box
@@ -577,23 +610,28 @@
 
    END SUBROUTINE extrap__fill_value_wrapper
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This subroutine
+   !> This subroutine compute point to be extrapolated, then extrapolate point.
    !> 
    !> @details 
+   !> optionaly, you could specify :<br/>
+   !>  - refinment factor (default 1)
+   !>  - offset between fine and coarse grid (default compute from refinment factor
+   !> as offset=(rho-1)/2) 
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
+   !> - November, 2013- Initial Version
    !
-   !> @param[inout] td_var : variable structure
-   !> @param[in] cd_method : extrapolation method
-   !> @param[in] id_iext : number of points to be extrapolated in i-direction
-   !> @param[in] id_jext : number of points to be extrapolated in j-direction
-   !> @param[in] id_kext : number of points to be extrapolated in k-direction
-   !> @param[in] id_radius : radius of the halo used to compute extrapolation
-   !> @param[in] id_maxiter : maximum nuber of iteration
-   !-------------------------------------------------------------------
-   !> @code
+   !> @param[inout] td_var    variable structure
+   !> @param[in] cd_method    extrapolation method
+   !> @param[in] id_iext      number of points to be extrapolated in i-direction
+   !> @param[in] id_jext      number of points to be extrapolated in j-direction
+   !> @param[in] id_kext      number of points to be extrapolated in k-direction
+   !> @param[in] id_radius    radius of the halo used to compute extrapolation
+   !> @param[in] id_maxiter   maximum number of iteration
+   !> @param[in] td_level     fine grid array of level
+   !> @param[in] id_offset    array of offset between fine and coarse grid 
+   !> @param[in] id_rho       array of refinment factor
+   !-------------------------------------------------------------------
    SUBROUTINE extrap__fill_value( td_var, cd_method, &
    &                              id_iext, id_jext, id_kext, &
@@ -619,11 +657,8 @@
 
       INTEGER(i4), DIMENSION(:,:,:)  , ALLOCATABLE :: il_detect
-      INTEGER(i4)                                  :: il_radius
-      INTEGER(i4)                                  :: il_iter
 
       TYPE(TATT)                                   :: tl_att
 
       ! loop indices
-      INTEGER(i4) :: jl
       !----------------------------------------------------------------
 
@@ -637,5 +672,4 @@
       &                                 id_rho,           &
       &                                 id_ext=(/id_iext, id_jext, id_kext/) )
-
       !2- add attribute to variable
       cl_extrap=fct_concat(td_var%c_extrap(:))
